import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Observable } from 'rxjs/Observable';
import { ReplaySubject } from 'rxjs/ReplaySubject';
import { Subject } from 'rxjs/Subject';
import { ReduxStateConstructor } from './constructor';
import { ReduxStateSelectorDataType } from './selector/data-type';
export declare class ReduxStateSelector {
    private expression;
    private context;
    private static readonly DELIMITER;
    constructor(expression: string, context?: ReduxStateConstructor);
    asObservable<S>(): Observable<S>;
    asBehaviorSubject<S>(): BehaviorSubject<S>;
    asReplaySubject<S>(): ReplaySubject<S>;
    asSubject<S>(): Subject<S>;
    getByDataType<S>(dataType: ReduxStateSelectorDataType, initialValue: S): ReplaySubject<S> | Subject<S> | BehaviorSubject<S> | Observable<S>;
    getValueFromState<T, S = {}>(state: S): T;
    private getSubjectByDataType<S>(dataType, initialValue);
    private static isPropertyKeyValid(propertyKey);
}
